// In this example, AesCrypt() is used
// to encrypt a single buffer
// This is available only in Xbase++ 2.0 or later
#INCLUDE "DBESYS.PRG"

PROCEDURE MAIN()

// LOCAL cKey := 'D4C43B6835856X70323BA0B51E98DF8F'
LOCAL cKey := 'Now Is The Time For All Good Men To Come To the Aid of Their Country'

LOCAL cEncryptedString, cDecryptedString, CustNumber

cKey := Substr(cKey,1,32)

? cKey

SET DEFAULT TO .\DATA
USE CUSTOMER

//encrypt the customer number from Customer Table
CustNumber:= Cust_nmbr
cEncryptedString := Encrypt(CustNumber,cKey)

? Trim(cEncryptedString), Len(cEncryptedString),"Encrypted Cust Nmb"

DBRLOCK()
REPLACE Bill_name with Trim(cEncryptedString)
UNLOCK

//this works ->cDecryptedString := Trim(Decrypt( cEncryptedString, cKey ))
?Bill_name, Len(trim(Bill_Name)), "Bill_Name"
//this does not work
cDecryptedString := Decrypt( Trim(Bill_name), cKey )
? cDecryptedString, Len(cDecryptedString)    , "Decrypted String from File"

wait

RETURN


#Pragma Library("ASUED10.LIB")
#include "crypt.ch"
#include "dcdialog.ch"


FUNCTION Encrypt( cString, cKey )

LOCAL oAes, cResult

// create AesCrypt()-instance using the key
oAes := AesCrypt():new(cKey)

// prepare input buffer length
oAes:prepareBuffer(@cString)

// encrypt buffer
cResult := oAes:encrypt(cString)

RETURN cResult

* -----------

FUNCTION Decrypt( cEncryptedString, cKey )

LOCAL oAes, cResult

// create AesCrypt()-instance using the key
oAes := AesCrypt():new(cKey)

// prepare input buffer length
oAes:prepareBuffer(@cEncryptedString)

// encrypt buffer
cResult := oAes:decrypt(cEncryptedString)

RETURN cResult


/*
This program is here to demonstrate how easy
it is to add Advantage Server to an existing
application.

If you comment out #INCLUDE "DBESYS.PRG", the
application will use the default DBFNTX
driver to open the databases, otherwise it
will use the ADSDBE driver and the options
setup in DBESYS.PRG.
*/