/*
This sample program demonstrates DES Encryption and Decryption
using DESDLL.DLL
*/

#INCLUDE "dll.CH"
#INCLUDE "dcdialog.CH"

FUNCTION Main()

LOCAL cEncryptionString

cEncryptionString := Encrypt('This is my Credit Card Number: 1234-6789-0045-3345 exp 12/11')

? 'Encrypted String:', cEncryption String
? 'Decrypted String:', Decrypt(cEncryptionString)
?
?

cEncryptionString := Encrypt('This is my Another Card Number: 1244-6798-0054-3354 exp 12/13')

? 'Encrypted String:', cEncryption String
? 'Decrypted String:', Decrypt(cEncryptionString)

WAIT

RETURN nil

* --------------

Function Decrypt(inStr)

LOCAL cKey, cOutput := Space(512)

STATIC snDll, scCall

IF Empty(snDll)
  snDll := DllLoad('DESDLL.DLL')
  scCall := DllPrepareCall(snDll,DLL_STDCALL,'DESDecrypt')
ENDIF
cKey := 'DonnaySoftware'

DllExecuteCall(scCall,inStr,cKey,@cOutput)

RETURN Strtran(RTrim(cOutput),Chr(0),'')

* --------------

Function Encrypt(inStr)

LOCAL cKey, cOutput := Space(512)

STATIC snDll, scCall

IF Empty(snDll)
  snDll:=DllLoad('DESDLL.DLL')
  scCall:=DllPrepareCall(snDll,DLL_STDCALL,'DESEncrypt')
ENDIF
cKey := 'DonnaySoftware'

DllExecuteCall(scCall,inStr,cKey,@cOutput)

RETURN Left(RTrim(cOutput),Len(cOutput)-1)


